/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package moe.nekojimi.musicsearcher.parsers;

import java.io.InputStream;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.Collection;

/**
 *
 * @author jim
 */
public abstract class Parser<D,O>
{
    public abstract D getDocument(InputStream input);
    
    public abstract Collection<O> getResults(D document, String selector);
    public Collection<O> getResults(InputStream input, String selector)
    {
        return getResults(getDocument(input), selector);
    }
    
    public abstract String getField(O object, String selector);
    public abstract URL getURLField(O object, URL baseURL, String selector) throws MalformedURLException;

}
